'use strict';
var Bar = function (ps, p1, p2, c) {
	NonDynamicalObject.call(this, ps, 0, 0, c);
	// 縦線の場合は特別
	if (p1.x === p2.x) {
		this.a = undefined;
		if (p1.y > p2.y) {
			this.x1 = p2.makeCopy();
			this.x2 = p1.makeCopy();
		} else {
			this.x1 = p1.makeCopy();
			this.x2 = p2.makeCopy();
		}
		// p1.x==p2.xの時は、x1.y<x2.yになるようにする。 
		this.b = p1.y;
		this.houkou = new Vector(0, 1);
		this.housen = new Vector(-1, 0);
		return;
	}
	if (p1.x < p2.x) {
		this.x1 = p1.makeCopy();
		this.x2 = p2.makeCopy();
	} else {
		this.x1 = p2.makeCopy();
		this.x2 = p1.makeCopy();
	} // これで、this.x1<=this.x2 が保証される。
	// this.aとthis.bはバーの線をy=ax+bと表現した時のa,b。
	this.a = (p1.y - p2.y) / (p1.x - p2.x);
	this.b = p1.y - this.a * p1.x;
	// 直線の方向ベクトルと法線ベクトル
	this.houkou = (new Vector(1, this.a)).quot(Math.sqrt(1 + this.a * this.a));
	this.housen = (new Vector(-this.a, 1)).quot(Math.sqrt(1 + this.a * this.a));
};
Bar.prototype = Object.create(NonDynamicalObject.prototype);
Bar.prototype.constructor = Bar;
Bar.prototype.interactionForce = function (to) {
	var r;
	if (this.a === undefined) {
		r = to.npos.x - this.x1.x;
		//	} else if (this.a >1) {
		//		r = ((to.npos.y - this.b)/this.a - to.npos.x)/Math.sqrt(1+1/(this.a*this.a));
	} else {
		r = (to.npos.x * this.a + this.b - to.npos.y) / Math.sqrt(1 + this.a * this.a);
	}
	var rr = Math.abs(r) - to.r;

	if (rr > 0) {
		return new Vector(0, 0);
	} else {
		var diff, difflen, xx;
		if (this.a === undefined) {
			xx = to.npos.y;
			if (this.x1.y <= xx && xx <= this.x2.y) {
				if (r > 0) {
					return this.housen.prod(2000 * rr);
				} else {
					return this.housen.prod(-2000 * rr);
				}
			}
		} else {
			xx = to.npos.x - r * this.a / Math.sqrt(1 + this.a * this.a);
			if (this.x1.x <= xx && xx <= this.x2.x) {
				if (r > 0) {
					return this.housen.prod(2000 * rr);
				} else {
					return this.housen.prod(-2000 * rr);
				}
			}
		}
		diff = to.npos.diff(this.x1);
		difflen = diff.length();
		if (difflen < to.r) {
			return diff.prod(1000 * (to.r - difflen) / difflen);
		} else {
			diff = to.npos.diff(this.x2);
			difflen = diff.length();
			if (difflen < to.r) {
				return diff.prod(1000 * (to.r - difflen) / difflen);
			} else {
				return new Vector(0, 0);
			}
		}
	}
};
Bar.prototype.draw = function () {
	this.ps.writeLine(this.x1.x, this.x1.y, this.x2.x, this.x2.y, this.col);
};

var Polygon = function (ps, p1, p2, p3) {
	this.bList = [];
	var N = arguments.length - 1;
	if (N < 3) {
		return; // 三角形以下なので何もせず去る。
	}
	var i, i2;
	for (i = 0; i < N; i++) {
		if (i + 1 === N) {
			i2 = 0;
		} else {
			i2 = i + 1;
		}
		var b = new Bar(ps, arguments[i + 1], arguments[i2 + 1]);
		this.bList.push(b);
	}
};
